.\" $NetBSD: mount_cd9660.8,v 1.27 2008/05/02 18:11:05 martin Exp $
.\"
.\" Copyright (c) 2004 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\"
.\" Copyright (c) 1993, 1994
.\"     The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software donated to Berkeley by
.\" Christopher G. Demetriou.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)mount_cd9660.8	8.3 (Berkeley) 3/27/94
.\"
.Dd January 3, 2009
.Dt MOUNT_CD9660 8
.Os
.Sh NAME
.Nm mount_cd9660
.Nd mount an ISO-9660 filesystem
.Sh SYNOPSIS
.Nm
.Op Fl o Ar options
.Ar special node
.Sh DESCRIPTION
The
.Nm
command attaches the ISO-9660 filesystem residing on the device
.Pa special
to the global filesystem namespace at the location indicated by
.Pa node .
Both
.Ar special
and
.Ar node
are converted to absolute paths before use.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl o
Options are specified with a
.Fl o
flag followed by a comma separated string of options.
Besides options mentioned in
.Xr mount 8
man page, following cd9660-specific options are supported:
.Bl -tag -width indent
.It Cm extatt
Enable the use of extended attributes.
.It Cm gens
Do not strip version numbers on files and leave the case of the filename
alone.
(By default, uppercase characters are translated to lowercase,
and if there are files with different version numbers on the disk,
only the last one will be listed.)
.Pp
In either case, files may be opened without giving a
version number, in which case you get the last one, or by explicitly
stating a version number (albeit it's quite difficult to know it, if
you are not using the
.Cm gens
option), in which case you get the specified version.
.It Cm nocasetrans
A synonym for
.Cm nomaplcase .
.It Cm nojoliet
Do not make use of Joliet extensions for long filenames which
may be present in the filesystem.
.Pp
Interpretation of Joliet extensions is enabled by default, Unicode
file names are encoded into UTF-8.
.It Cm nomaplcase
File names on cd9660 cdrom without Rock Ridge extension present
should be uppercase only.
By default, cd9660 recodes file
names read from a non-Rock Ridge disk to all lowercase characters.
.Cm nomaplcase
turns off this mapping.
.It Cm norrip
Do not use any Rockridge extensions included in the filesystem.
.It Cm nrr
Same as
.Cm norrip .
For compatibility with Solaris only.
.It Cm rrcaseins
Makes all lookups case-insensitive even for CD-ROMs with Rock-Ridge
extensions (for Rock-Ridge, default is case-sensitive lookup).
.El
.El
.Pp
For compatibility with previous releases, following obsolete flags are
still recognized:
.Bl -tag -width indent
.It Fl e
Same as
.Fl o
.Cm extatt .
.It Fl j
Same as
.Fl o
.Cm nojoliet .
.It Fl g
Same as
.Fl o
.Cm gens .
.It Fl r
Same as
.Fl o
.Cm norrip .
.El
.Sh SEE ALSO
.Xr mount 2 ,
.Xr unmount 2 ,
.Xr fstab 5 ,
.Xr mount 8 ,
.Xr mscdlabel 8
.Sh HISTORY
The
.Nm
utility first appeared
.Bx 4.4 .
Support for Joliet filesystem appeared in
.Nx 1.4 .
Options
.Cm nomaplcase
and
.Cm rrcaseins
were added in
.Nx 1.5 .
UTF-8 encoding of Unicode file names for Joliet filesystems was added in
.Nx 3.0 .
.Sh NOTES
For Joliet filesystems, the Unicode file names used to be filtered
to ISO-8859-1 character set.
This changed in
.Nx 3.0 ,
file names are encoded into UTF-8 now by default.
The behaviour is controllable by the
.Em vfs.cd9660.utf8_joliet
sysctl; the former behaviour is available by setting it to 0.
.Sh BUGS
For some cdroms the information in the Rock Ridge extension is wrong
and the cdrom needs to be mounted with "norrip".
A sign that something is wrong is that the
.Xr stat 2
system call returns
.Er EBADF
causing, e.g., "ls -l" to fail with "Bad file descriptor".
.Pp
The cd9660 filesystem does not support the original "High Sierra"
("CDROM001") format.
.Pp
POSIX device node mapping is currently not supported.
.Pp
Version numbers are not stripped if Rockridge extensions are in use.
In this case, you have to use the original name of the file as recorded
on disk, i.e. use uppercase and append the version number to the file.
.Pp
There is no ECMA support.
